
-module(basic).
% Export the start function
-export([start/0]).
-compile([export_all]).

% Define a function that prints a message
print_message(Name) ->
    io:format("Hello from process ~s!~n", [Name]).

% Define the start function that spawns processes
start() ->
    % Spawn two processes that run the print_message function
    Pid1 = spawn(fun() -> print_message("Process 1") end),
    Pid2 = spawn(fun() -> print_message("Process 2") end),
    Pid3 = spawn(fun() -> io:format("Process 3~n") end),
    
    % Output the PIDs of the spawned processes
    io:format("Spawned process 1 with PID: ~p~n", [Pid1]),
    io:format("Spawned process 2 with PID: ~p~n", [Pid2]),
    io:format("Spawned process 3 with PID: ~p~n", [Pid3]).

% note these Pid1, etc. are not available in the shell
% after running 
% > c(basic)
% > basic:start().
%
% as they are local to the module "basic"
