
-module(msgs).
-compile([export_all]).

start() ->
   Pid = spawn(fun() -> loop(no_match) end),
   send_msgs(Pid).


loop(ST) ->
   receive
      {set_state, NewST} -> 
         io:format("State changed to: ~p~n",[NewST]),
         loop(NewST);
    
      {data, Val} when ST =:= match ->   % =:= is exact eq, no type conversions
         io:format("Matched data: ~p~n", [Val]),
         loop(ST)
   end.

send_msgs(P) ->
   io:format(">>sending msg1: {data, 42}~n"),
   P ! {data, 42},             % wont match at first
   io:format(">>sending msg2: {set_state, match}~n"),
   P ! {set_state, match},     % now the state is changed
   timer:sleep(1000), 
   io:format(">>sending msg3: {data, 142}~n"),
   P ! {data, 142},             % now this matches
   ok. 
