
-module(spawner).
-export([go/2, looper/2, qlooper/2, plooper/2]).

% this demo simply makes LOTS of processes, small ones
% so you can see how your machine loads up
% both from the work of spawning (it takes time)
% and from all those processes running and the 
% OTS keeping track of them and allocating them
% time slices on the cores in your machine

% the function looper is the work load... it counts down
% from some starting point and announces when its done.
%
% bad hack... to make looper an infinite loop work load
% rather than counting down... call it with the X parameter
% value 0 or smaller, it will count "down" forever
% 
% the parameter N is the ID number of the process
% when looper is spawned as a process

looper(N,1) -> done;
looper(N,X) -> looper(N,X-1).

qlooper(N,1) when N rem 100 == 0 -> io:write("done ~p~n",[N]);                
qlooper(N,X) -> qlooper(N,X-1).

plooper(N,1) -> io:fwrite("done ~p~n",[N]);
plooper(N,X) -> plooper(N,X-1).

%============================================================

% this function spawns some number N of processes, each
% process running the looper work load.

go(N,_) when N =< 0 -> spawning_done;
go(N,L) when (N rem 1000) == 0 -> 
           spawn(?MODULE, plooper, [N,L]),
           go(N-1,L);
go(N,L) -> spawn(?MODULE, looper, [N,L]),
           go(N-1,L).


% example:  go(100000,200000) will make 100K numbered processes
% and the constant is set at 200000 loops for looper countdown
