
-module(trap2).
-compile([export_all]).

start() ->
    spawn(?MODULE, parent, []).

parent() ->
    process_flag(trap_exit, true),
    CP1 = spawn_link(?MODULE, child1, []),
    io:format("Parent: Spawned child 1 process ~p~n", [CP1]),
    CP2 = spawn_link(?MODULE, child2, []),
    io:format("Parent: Spawned child 2 process ~p~n", [CP2]),
    wait_loop(CP1,CP2).

wait_loop(P1,P2) ->
    receive
        {'EXIT', CP, Reason} ->
            io:format("Parent: Caught exit from child (~p), reason: ~p~n", [CP, Reason]),
	    wait_loop(P1,P2)
        after 12000 -> io:format("parent exiting~n")
    end.

child1() ->
    io:format("Child 1: Running...~n"),
    timer:sleep(5000),
    io:format("Child 1: Exiting now~n"),
    exit(normal).

child2() ->
    io:format("Child 2: Running...~n"),
    timer:sleep(2000),
    io:format("Child 2: Crashing now~n"),
    exit(crash).

