
-module(traps).
-compile([export_all]).

% Spawn a new process that starts with function process/0
run() -> PID = spawn(fun process/0),
         io:format("spawned process ~p~n",[PID]).

process() -> io:format("Starting process~n"),
    process_flag(trap_exit, true),  % Turn trapping on for the process
    io:format("Trapping exits turned on~n"),
    f1(),  % Call f1
    % is trapping on or off here ?
    io:format("back from f1 call~n").

f1() -> io:format("in f1:~n"),
    % in f1 the trap_exit flag is off 
    % the flag is 'global' to the process, not to any function
    f2(),
    io:format("back from f2 call~n").
    % then return to f1 call in process

f2() -> io:format("in f2:~n"),
    process_flag(trap_exit, false), % Turn trapping off in f2
    io:format("Trapping exits turned off~n").
    % then return to f2 call in f1


